<?php

class DispletRetsIdxUpdatesController extends DispletRetsIdxPlugin {
	public static function maybe_update() {
		$last_version = DispletRetsIdxSettingsController::get_option( 'version' );
		// If last version still using old update methodology
		if ( empty( $last_version ) || version_compare( '2.0.26', $last_version, '>' ) ) {
			$user_role_version = get_option( 'displet_rets_idx_user_role_version' );
			if ( empty( $user_role_version ) || $user_role_version < 2 ) {
				DispletRetsIdxUsersController::add_custom_user_role_for_leads();
				if ( $user_role_version < 2 ) {
					DispletRetsIdxUsersUpdatesController::upgrade_users_to_role_2();
				}
			}
			$user_role_version_agents = get_option( 'displet_rets_idx_user_role_version_agents' );
			if ( empty( $user_role_version_agents ) || $user_role_version_agents < 2 ) {
				DispletRetsIdxUsersController::add_custom_user_role_for_agents();
			}
			$user_role_version_admin = get_option( 'displet_rets_idx_user_role_version_admin' );
			if ( empty( $user_role_version_admin ) || $user_role_version_admin < 1 ) {
				DispletRetsIdxUsersController::add_custom_capabilities_to_admin();
			}
			$version = get_option( 'displet_rets_idx_options_version' );
			if ( empty( $version ) || $version < 1 ) {
				if ( empty( $version ) || $version < 1 ) {
					DispletRetsIdxSettingsUpdatesController::update_settings_to_version_1();
				}
				update_option( 'displet_rets_idx_options_version', 1 );
			}
		}
		// If last version not current
		if ( version_compare( self::$plugin_version, $last_version, '>' ) ) {
			if ( version_compare( '2.0.24', $last_version, '>' ) ) {
				self::update_to_2_0_24();
			}
			if ( version_compare( '2.0.25', $last_version, '>' ) ) {
				self::update_to_2_0_25();
			}
			if ( version_compare( '2.0.26', $last_version, '>' ) ) {
				self::update_to_2_0_26();
			}
			if ( version_compare( '2.0.27', $last_version, '>' ) ) {
				self::update_to_2_0_27();
			}
			if ( version_compare( '2.0.28', $last_version, '>' ) ) {
				self::update_to_2_0_28();
			}
			if ( version_compare( '2.0.30', $last_version, '>' ) ) {
				self::update_to_2_0_30();
			}
			if ( version_compare( '2.0.31', $last_version, '>' ) ) {
				self::update_to_2_0_31();
			}
			if ( version_compare( '2.0.46', $last_version, '>' ) ) {
				self::update_to_2_0_46();
			}
			DispletRetsIdxSettingsController::update_option( 'version', self::$plugin_version );
		}
	}

	private static function update_to_2_0_24() {
		DispletRetsIdxUsersUpdatesController::schedule_register_non_api_users_with_api_cron();
	}

	private static function update_to_2_0_25() {
		DispletRetsIdxRewriteController::reset_flush_rewrite_rules();
	}

	private static function update_to_2_0_26() {
		DispletRetsIdxSettingsUpdatesController::change_to_multi_checkbox_from_one_per_line_textarea( 'city_include_filter' );
	}

	private static function update_to_2_0_27() {
		DispletRetsIdxUsersUpdatesController::save_new_meta_values_for_user_searches();
	}

	private static function update_to_2_0_28() {
		DispletRetsIdxUsersController::add_custom_capabilities_to_admin();
	}

	private static function update_to_2_0_30() {
		DispletRetsIdxRewriteController::reset_flush_rewrite_rules();
	}

	private static function update_to_2_0_31() {
		DispletRetsIdxSettingsUpdatesController::update_setting( 'require_registration_to_view_properties', '1' );
	}

	private static function update_to_2_0_46() {
		DispletRetsIdxUsersUpdatesController::maybe_add_property_filter_to_saved_searches();
	}
}

?>