<?php

class DispletRetsIdxQuickSearchWidgetsController extends DispletRetsIdxPlugin {
	public static function register_widgets() {
		register_widget( 'DispletRetsIdxQuickSearchWidget1' );
		$i = 2;
		while ( DispletRetsIdxSearchFieldWidgetController::is_quick_search_form_column_used( $i, 1 ) ) {
			register_widget( 'DispletRetsIdxQuickSearchWidget' . $i );
			$i++;
		}
	}

	public static function widget( $args, $instance, $form ) {
		// Widget output
		extract(  $args  );
		global $displetretsidx_option;
        $title = empty( $instance['title'] ) ? '' : apply_filters( 'widget_title', $instance['title'] );
		$model = array(
			'options' => $displetretsidx_option,
			'title' => $title,
			'id' => $form
		 );
	    return $before_widget . DispletRetsIdxTemplatesController::get_template( 'displet-quick-search.php', $model ) . $after_widget;
	}

	public function form( $instance ) {
        $title = isset( $instance['title'] ) ? strip_tags( $instance['title'] ) : 'Search Properties';
        $output =
			'<p>
				<label for="' . $this->get_field_id( 'title' ) . '">Title: </label>
				<input class="widefat" id="' . $this->get_field_id( 'title' ) . '" name="' . $this->get_field_name( 'title' ) . '" type="text" value="' . esc_attr( $title ) . '" />
			</p>';
		return $output;
	}
}

?>