<?php

class DispletRetsIdxAdminPagesModel extends DispletRetsIdxPlugin {
	protected static $_model = array(
		'is_lead_manager_page' => false,
		'is_saved_properties_page' => false,
		'is_saved_searches_page' => false,
	);

	protected static function build_model() {
		self::determine_page();
		self::set_first_city();
		self::set_url();
	}

	private static function determine_page() {
		$screen = get_current_screen();
		if ( !empty( $screen->id ) ) {
			if ( $screen->id === 'displet-tools_page_' . self::$_slugs['lead_manager_page'] ) {
				self::$_model['is_lead_manager_page'] = true;
			}
			else if ( $screen->id === 'toplevel_page_' . self::$_slugs['saved_properties_page'] ) {
				self::$_model['is_saved_properties_page'] = true;
			}
			else if ( $screen->id === 'toplevel_page_' . self::$_slugs['saved_searches_page'] ) {
				self::$_model['is_saved_searches_page'] = true;
			}
		}
	}

	private static function set_first_city() {
		self::$_model['first_city'] = !empty( self::$_field_options['city'][0] ) ? self::$_field_options['city'][0] : '';
	}

	private static function set_url() {
		self::$_model['url'] = self::$_url;
	}
}

?>